# ------------
# QPACE / qrun
# ------------
#
# Signal handling utilities
#
# $Id: sighandler.pm 3468 2010-04-06 20:02:01Z pleiter $
#---------------------------------------------------------------------------------------------------

package sighandler;

use strict;

use sigtrap 'handler', \&killExit, qw(INT TERM);

use logger;
use partition;
use remote;

our $partition = undef;
our $rcmd = undef;

#---------------------------------------------------------------------------------------------------
# Initialization routine
#---------------------------------------------------------------------------------------------------

sub init($$)
{
  my ($p, $c) = @_;

  die "Illegal argument" unless (ref($p) eq "REF");
  die "Illegal argument" unless (ref($$p) eq "Partition");

  $partition = $p;
  $rcmd = $c;
}


#---------------------------------------------------------------------------------------------------
# Signal handler
#---------------------------------------------------------------------------------------------------

sub killExit
{
  logger::error("Received signal $_[0]!\n");

  if (defined $partition && defined $rcmd) {
    remote::exec($partition, "$rcmd");
  }

  exit(1);
}


1;
