# ------------
# QPACE / qrun
# ------------
#
# Torus network functions
#
# $Id: tnw.pm 3467 2010-04-06 20:01:35Z pleiter $
#---------------------------------------------------------------------------------------------------

package tnw;

use strict;

use remote;

my $torus_ctl = "/tmp/torus_ctl";


#---------------------------------------------------------------------------------------------------
# Initialise torus network
#---------------------------------------------------------------------------------------------------

sub init($)
{
  my ($partition) = @_;

  #FIXME: temporary solution
  remote::copy_to($partition, "$ENV{QRUNDIR}/files/torus_ctl", "$torus_ctl");

  remote::exec($partition, "modload torus");
  remote::exec($partition, "$torus_ctl" .
                           " --nc0=" . $$partition->{nc0}->apos_str .
                           " --nc1=" . $$partition->{nc1}->apos_str .
                           " --bc="  . $$partition->{bc} .
                           " set-topo");
  remote::exec($partition, "$torus_ctl rst-phy");
  remote::exec($partition, "$torus_ctl cfg-if");
  remote::exec($partition, "$torus_ctl rst-lnk");
  remote::exec($partition, "$torus_ctl ro");
}


1;
