#!/bin/bash

pidfile="$(dirname $0)/pid"
max_depth=10

if [ -f "$pidfile" ]; then
	ppid=$( cat $pidfile )
else
	exit 1
fi

depth=0
lst="$ppid"
while true; do
    pre_lst=$( echo "${lst}" | sort | uniq | sed -e '/^[ ]*$/d' )
    tmp=""
    for ppid in ${lst}; do 
        tmp="${tmp}
$( ps --ppid $ppid  --no-headers -o pid )"
    done
    lst="${lst}
${tmp}"
    lst=$( echo "${lst}" | sort | uniq | sed -e '/^[ ]*$/d' )
    if test "${pre_lst}" = "${lst}"; then break;
    fi
    depth=$(( $depth + 1 ))
    if test $depth -gt $max_depth; then break; fi
done

for pid in ${lst}; do
    for ((i=0; i<60; i++)); do
        kill -SIGIO $pid > /dev/null 2>&1
        test -e "/proc/$pid" || break;
    done
done

